'use strict';

var SolicitacaoWorkflowController = angular.module('SolicitacaoWorkflowController', []);

SolicitacaoWorkflowController.controller('SolicitacaoWorkflowCtrl', ['$scope', '$routeParams', '$filter', '$location', 'Construcao', 'Material', 'Solicitacao', 'Almoxarifado', 'Cotacao', 'Fornecedor', 'Compra', 'CacheApp', 'MsgBox',
 ($scope, $routeParams, $filter, $location, Construcao, Material, Solicitacao, Almoxarifado, Cotacao, Fornecedor, Compra, CacheApp, MsgBox) => {

    $scope.showButton = (solicitacao, chave) => {
        var acessos = $scope.construcao ? $scope.construcao.Acessos : $scope.getObraById(solicitacao.IdConstrucao).Acessos;
        const exibir = {
            'INI_FASE': () => (!solicitacao.DataFim && (acessos.indexOf(solicitacao.ChaveNextWorkflow) >= 0)),
            'FIM_FASE': () => (solicitacao.DataFim && (acessos.indexOf(solicitacao.ChaveNextWorkflow) >= 0) && solicitacao.ChaveNextWorkflow != $scope.WorkFlowEnum.CANCELADO),
            'INI_SOLICITACAO': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.SOLICITACAO) && (acessos.indexOf($scope.WorkFlowEnum.SOLICITACAO) >= 0)),
            'FIM_SOLICITACAO': () => (solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.SOLICITACAO) && (acessos.indexOf($scope.WorkFlowEnum.SOLICITACAO) >= 0)),
            'INI_ALMOXARIFADO': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.ALMOXARIFADO) && (acessos.indexOf($scope.WorkFlowEnum.ALMOXARIFADO) >= 0)),
            'INI_COTACAO': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.COTACAO) && (acessos.indexOf($scope.WorkFlowEnum.COTACAO) >= 0)),
            'INI_APROVACAO': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.ANALISE) && (acessos.indexOf($scope.WorkFlowEnum.ANALISE) >= 0)),
            'INI_COMPRA': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.COMPRA) && (acessos.indexOf($scope.WorkFlowEnum.COMPRA) >= 0)),
            'FIM_COMPRA': () => (solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.COMPRA) && (acessos.indexOf($scope.WorkFlowEnum.COMPRA) >= 0)),
            'GET_COMPRA_ENTREGUE': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.ENTREGUE) && (acessos.indexOf($scope.WorkFlowEnum.ENTREGUE) >= 0)),
            'GET_COMPRA_RETIRADA': () => (!solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.RETIRADA) && (acessos.indexOf($scope.WorkFlowEnum.RETIRADA) >= 0)),
            'FIM_ENTREGUE': () => (solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.ENTREGUE) && (acessos.indexOf($scope.WorkFlowEnum.ENTREGUE) >= 0)),
            'FIM_RETIRADA': () => (solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.RETIRADA) && (acessos.indexOf($scope.WorkFlowEnum.RETIRADA) >= 0)),
            'FIM_CONCLUIDO': () => (solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.CONCLUIDO) && (acessos.indexOf($scope.WorkFlowEnum.SOLICITACAO) >= 0)),
            'BTN_CANCELAR': () => (acessos.indexOf($scope.WorkFlowEnum.CANCELADO) >= 0) && (solicitacao.Chave != $scope.WorkFlowEnum.CANCELADO), //&& (solicitacao.Chave != $scope.WorkFlowEnum.COMPRA) && (solicitacao.Chave != $scope.WorkFlowEnum.ENTREGUE) && (solicitacao.Chave != $scope.WorkFlowEnum.RETIRADA) && (solicitacao.Chave != $scope.WorkFlowEnum.CANCELADO),
            'BTN_EXCUIR': () => (solicitacao.DataFim && (solicitacao.Chave == $scope.WorkFlowEnum.CANCELADO) && (acessos.indexOf($scope.WorkFlowEnum.EXCLUIR) >= 0)),
            'BTN_SOLICITACAO': () => (!solicitacao.DataFim && ((acessos.indexOf(solicitacao.ChaveNextWorkflow) >= 0) || (solicitacao.Chave == $scope.WorkFlowEnum.SOLICITACAO))) && (solicitacao.Chave != $scope.WorkFlowEnum.ANALISE) && (solicitacao.Chave != $scope.WorkFlowEnum.COMPRA) && (solicitacao.Chave != $scope.WorkFlowEnum.ENTREGUE) && (solicitacao.Chave != $scope.WorkFlowEnum.RETIRADA) && (solicitacao.Chave != $scope.WorkFlowEnum.CANCELADO),
        }

        return exibir[chave]();
    }

    $scope.showFluxo = (solicitacao, chave) => {
        var acessos = $scope.construcao ? $scope.construcao.Acessos : $scope.getObraById(solicitacao.IdConstrucao).Acessos;
        const exibir = {
            'SOLICITACAO': () => ((acessos.indexOf($scope.WorkFlowEnum.SOLICITACAO) >= 0) || (acessos.indexOf($scope.WorkFlowEnum.ALMOXARIFADO) >= 0) || (acessos.indexOf($scope.WorkFlowEnum.COTACAO) >= 0)),
            'COTACAO': () => ( 
                    (acessos.indexOf($scope.WorkFlowEnum.COTACAO) >= 0 || acessos.indexOf($scope.WorkFlowEnum.ANALISE) >= 0 || acessos.indexOf($scope.WorkFlowEnum.COMPRA) >= 0 || acessos.indexOf($scope.WorkFlowEnum.ENTREGUE) >= 0 || acessos.indexOf($scope.WorkFlowEnum.RETIRADA) >= 0) 
                    && (solicitacao.Chave == $scope.WorkFlowEnum.COTACAO || solicitacao.Chave == $scope.WorkFlowEnum.ANALISE || solicitacao.Chave == $scope.WorkFlowEnum.COMPRA || solicitacao.Chave == $scope.WorkFlowEnum.ENTREGUE || solicitacao.Chave == $scope.WorkFlowEnum.RETIRADA || solicitacao.Chave == $scope.WorkFlowEnum.CONCLUIDO) ),
            'APROVACAO': () => ( ((acessos.indexOf($scope.WorkFlowEnum.ANALISE) >= 0) || (acessos.indexOf($scope.WorkFlowEnum.COMPRA) >= 0) || (acessos.indexOf($scope.WorkFlowEnum.ENTREGUE) >= 0) || (acessos.indexOf($scope.WorkFlowEnum.RETIRADA) >= 0)) && (solicitacao.Chave == $scope.WorkFlowEnum.ANALISE || solicitacao.Chave == $scope.WorkFlowEnum.COMPRA || solicitacao.Chave == $scope.WorkFlowEnum.ENTREGUE || solicitacao.Chave == $scope.WorkFlowEnum.RETIRADA || solicitacao.Chave == $scope.WorkFlowEnum.CONCLUIDO) ),
        }

        return exibir[chave]();
    }

    $scope.showLancamento = (solicitacao, aprova) => {
        var acessos = $scope.construcao ? $scope.construcao.Acessos : $scope.getObraById(solicitacao.IdConstrucao).Acessos;
        return aprova.IdNotaFiscal && acessos.indexOf('SET_DEBITO') >= 0;
    }

    $scope.showHint = (solicitacao) => {
        var label = '';
        if (!solicitacao.DataFim)
            switch (solicitacao.Chave) {
                case $scope.WorkFlowEnum.SOLICITACAO:
                    label = 'ENVIAR PEDIDO';
                    break;
                case $scope.WorkFlowEnum.ALMOXARIFADO:
                    label = 'ENVIAR PARA COTAÇÃO';
                    break;
                case $scope.WorkFlowEnum.COTACAO:
                    label = 'ENVIAR PARA APROVAÇÃO';
                    break;
                case $scope.WorkFlowEnum.ANALISE:
                    label = 'COTAÇÃO APROVADA?';
                    break;
                case $scope.WorkFlowEnum.COMPRA:
                    label = 'CONFIRMAR COMPRA';
                    break;
                case $scope.WorkFlowEnum.ENTREGUE:
                    label = 'CONFIRMAR ENTREGA';
                    break;
                case $scope.WorkFlowEnum.RETIRADA:
                    label = 'CONFIRMAR RETIRADA';
                    break;
            }
        else
            switch (solicitacao.ChaveNextWorkflow) {
                case $scope.WorkFlowEnum.ALMOXARIFADO:
                    label = 'ATENDER TRIAGEM';
                    break;
                case $scope.WorkFlowEnum.COTACAO:
                    label = 'ATENDER COTAÇÃO';
                    break;
                case $scope.WorkFlowEnum.ANALISE:
                    label = 'ATENDER APROVAÇÃO';
                    break;
                case $scope.WorkFlowEnum.COMPRA:
                    label = 'ATENDER COMPRA';
                    break;
                case $scope.WorkFlowEnum.ENTREGUE:
                    label = 'ATENDER ENTREGA';
                    break;
                case $scope.WorkFlowEnum.RETIRADA:
                    label = 'ATENDER RETIRADA';
                    break;
            }

        return label;
    }

    $scope.getSolicitacoes = () => {
        if ($scope.Notificacao) {
            var params = {
                IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
                IdConstrucao: $scope.Notificacao.IdConstrucao,
                IdSolicitacao: $scope.Notificacao.IdSolicitacao
            }

            $scope.paginacao.Load = true;
            Solicitacao.getSolicitacoes(params,
                (data) => {
                    $scope.listaSolicitacao = []
                    data.Instance.forEach(s => {
                        s.DataLimite = CacheApp.getData($filter("date")(s.DataLimite, 'yyyy-MM-ddT03:05:00Z'))
                        s.ValorCotacaoFinal = 0
                        s.CotacaoFinal = []
                        s.HintLabel = $scope.showHint(s)
                        $scope.getSolicitacaoWorkflow(s)
                        // if (s.Chave == $scope.WorkFlowEnum.COTACAO)
                        //     $scope.getResumoCotacaoFornecedores(s)
                        if (s.Chave == $scope.WorkFlowEnum.COTACAO
                            || s.Chave == $scope.WorkFlowEnum.ANALISE
                            || s.Chave == $scope.WorkFlowEnum.COMPRA
                            || s.Chave == $scope.WorkFlowEnum.ENTREGUE
                            || s.Chave == $scope.WorkFlowEnum.RETIRADA
                            || s.Chave == $scope.WorkFlowEnum.CONCLUIDO) {
                                $scope.getFornecedoresAll(s.IdClienteDono, () => { $scope.getSelecionadosCotacao(s) } )
                            }
                        else
                            if (!s.construcao)
                                s.construcao = $scope.getObraById(s.IdConstrucao)
                        $scope.getSolicitacaoItem(s)
                        $scope.listaSolicitacao.push(s)

                    })
                    $scope.paginacao.Load = false
                }
            )
        }
        else {
            var params = {
                Texto: $scope.pesquisa,
                IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
                IdConstrucao: JSON.stringify($scope.filterObra ? $scope.filterObra : []).replace('[','').replace(']',''),
                IdSolicitacaoSituacao: JSON.stringify($scope.filterSituacao ? $scope.filterSituacao : []).replace('[','').replace(']','').replace(new RegExp('"', 'g'), ''),
                Prioridade: JSON.stringify($scope.filterPrioridade ? $scope.filterPrioridade : []).replace('[','').replace(']',''),
                Paginacao: $scope.paginacao
            }
    
            $scope.paginacao.Load = true;
            Solicitacao.getSolicitacoesFiltro(params,
                (data) => {
                    $scope.listaSolicitacao = $scope.listaSolicitacao ? $scope.listaSolicitacao : [];
                    data.Instance.forEach(s => {
                        s.DataLimite = CacheApp.getData($filter("date")(s.DataLimite, 'yyyy-MM-ddT03:05:00Z'));
                        s.ValorCotacaoFinal = 0;
                        s.CotacaoFinal = [];
                        s.HintLabel = $scope.showHint(s);
                        $scope.getSolicitacaoWorkflow(s);
                        // if (s.Chave == $scope.WorkFlowEnum.COTACAO)
                        //     $scope.getResumoCotacaoFornecedores(s);
                        if (s.Chave == $scope.WorkFlowEnum.COTACAO
                            || s.Chave == $scope.WorkFlowEnum.ANALISE
                            || s.Chave == $scope.WorkFlowEnum.COMPRA
                            || s.Chave == $scope.WorkFlowEnum.ENTREGUE
                            || s.Chave == $scope.WorkFlowEnum.RETIRADA
                            || s.Chave == $scope.WorkFlowEnum.CONCLUIDO) {
                                $scope.getFornecedoresAll(s.IdClienteDono, () => { $scope.getSelecionadosCotacao(s); } );
                            }
                        else
                            if (!s.construcao)
                                s.construcao = $scope.getObraById(s.IdConstrucao)

                        $scope.getSolicitacaoItem(s);
                        $scope.listaSolicitacao.push(s);
                    })
                    $scope.paginacao.Load = false;
                }
            );
        }
    }

    $scope.getSolicitacoesRefresh = (solicitacao, isNewAdd) => {
        var params = {
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
            IdConstrucao: solicitacao.IdConstrucao,
            IdSolicitacao: solicitacao.IdSolicitacao
        }

        Solicitacao.getSolicitacoes(params,
            (data) => {
                data.Instance.forEach(s => {
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).Chave = s.Chave
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).ChaveNextWorkflow = s.ChaveNextWorkflow
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).ChaveSolicitacao = s.ChaveSolicitacao
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).DataFim = s.DataFim
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).DataInicio = s.DataInicio
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).IdSolicitacaoSituacao = s.IdSolicitacaoSituacao
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).IdSolicitacaoWorkflow = s.IdSolicitacaoWorkflow
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).NomeChaveNextWorkflow = s.NomeChaveNextWorkflow
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).Situacao = s.Situacao
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).Texto = s.Texto
                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).NomesInsumos = s.NomesInsumos

                    var sol = $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao)

                    $scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao).HintLabel = $scope.showHint(s);
                    $scope.getSolicitacaoWorkflow($scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao));

                    if (sol.Chave == $scope.WorkFlowEnum.COTACAO
                        || sol.Chave == $scope.WorkFlowEnum.ANALISE
                        || sol.Chave == $scope.WorkFlowEnum.COMPRA
                        || sol.Chave == $scope.WorkFlowEnum.ENTREGUE
                        || sol.Chave == $scope.WorkFlowEnum.RETIRADA
                        || sol.Chave == $scope.WorkFlowEnum.CONCLUIDO)
                            $scope.getFornecedoresAll(sol.IdClienteDono, () => { $scope.getSelecionadosCotacao($scope.listaSolicitacao.find(ls => ls.IdSolicitacao == s.IdSolicitacao)); } );

                    if (isNewAdd) {
                        var paramsLista = {
                            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
                            IdConstrucao: JSON.stringify($scope.filterObra ? $scope.filterObra : []).replace('[','').replace(']',''),
                            IdSolicitacaoSituacao: '',
                            Prioridade: '',
                            Paginacao: {
                                Index: 0,
                                Pages: 2
                            }
                        }
                
                        Solicitacao.getSolicitacoesFiltro(paramsLista,
                            (data) => {
                                var s = data.Instance[0]
                                s.DataLimite = CacheApp.getData($filter("date")(s.DataLimite, 'yyyy-MM-ddT03:05:00Z'));
                                s.ValorCotacaoFinal = 0;
                                s.CotacaoFinal = [];
                                s.HintLabel = $scope.showHint(s);
                                $scope.getSolicitacaoWorkflow(s);
                                if (s.Chave == $scope.WorkFlowEnum.COTACAO
                                    || s.Chave == $scope.WorkFlowEnum.ANALISE
                                    || s.Chave == $scope.WorkFlowEnum.COMPRA
                                    || s.Chave == $scope.WorkFlowEnum.ENTREGUE
                                    || s.Chave == $scope.WorkFlowEnum.RETIRADA
                                    || s.Chave == $scope.WorkFlowEnum.CONCLUIDO) {
                                        $scope.getFornecedoresAll(s.IdClienteDono, () => { $scope.getSelecionadosCotacao(s); } );
                                    }
                                else
                                    if (!s.construcao)
                                        s.construcao = $scope.getObraById(s.IdConstrucao)
        
                                $scope.getSolicitacaoItem(s);
                                $scope.listaSolicitacao.unshift(s)
                            }
                        )
                    }

                })

            }
        )
    }

    $scope.filtraObra = (e) => {
        clearTimeout($scope.timer); 

        if (e) {
            if ($scope.pesquisaOld == e.target.value) return;
            $scope.pesquisaOld = e.target.value;
        }

        if ($scope.construcoes && $scope.construcoes.length > 0) {
            $scope.filterObra = [];
            $scope.listaSelecao.forEach(l => {
                $scope.filterObra.push($scope.construcoes.filter(c => c.Id == l.id)[0].Id);
            });
        }
        else
            $scope.filterObra.push($scope.construcao.Id);

        $scope.filterSituacao = [];
        if ($scope.listaSituacaoSelecionada)
            $scope.listaSituacaoSelecionada.forEach(l => {
                $scope.filterSituacao.push($scope.listaSituacao.filter(s => s.Id == l.id)[0].Chave);
            });

        $scope.filterPrioridade = [];
        if ($scope.listaPrioridadeSelecionada)
            $scope.listaPrioridadeSelecionada.forEach(l => {
                $scope.filterPrioridade.push($scope.listaPrioridade.filter(s => s.Id == l.id)[0].Id);
            });

        $scope.timer = setTimeout( () => {
            $scope.inicializaPaginacao();
            $scope.getSolicitacoes();
        }, 1000);
    }

    $scope.inicializaPaginacao = () => {
        $scope.listaSolicitacao = undefined;
        $scope.paginacao = {
            Index: 0,
            Pages: 10
        };
    }

    $scope.abrirSolicitacao = (s) => {
        s.open = !s.open

        if (!s.open) return;

        if (s.Chave == $scope.WorkFlowEnum.COTACAO)
            $scope.getResumoCotacaoFornecedores(s);
    }

    $scope.getSolicitacaoWorkflow = (solicitacao) => {
        Solicitacao.getSolicitacaoWorkflow(solicitacao.IdSolicitacao, 
            (data) => {
                solicitacao.listaWorkFlow = data.Instance;
                for (var i in solicitacao.listaWorkFlow) {
                    solicitacao.listaWorkFlow[i].DataInicio = CacheApp.getData($filter("date")(solicitacao.listaWorkFlow[i].DataInicio, 'yyyy-MM-ddT03:05:00Z'));
                    switch (solicitacao.listaWorkFlow[i].Chave) {
                        case $scope.WorkFlowEnum.SOLICITACAO:
                            solicitacao.SOLICITACAO = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.ALMOXARIFADO:
                            solicitacao.ALMOXARIFADO = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.COTACAO:
                            solicitacao.COTACAO = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.ANALISE:
                            solicitacao.ANALISE = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.APROVADA:
                            solicitacao.ANALISE = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.NAO_APROVADA:
                            solicitacao.ANALISE = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.COMPRA:
                            solicitacao.COMPRA = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.ENTREGUE:
                            solicitacao.ENTREGUE = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                        case $scope.WorkFlowEnum.RETIRADA:
                            solicitacao.RETIRADA = {
                                Nome: solicitacao.listaWorkFlow[i].Cliente,
                                Data: solicitacao.listaWorkFlow[i].DataFim ? solicitacao.listaWorkFlow[i].DataFim : solicitacao.listaWorkFlow[i].DataInicio
                            };
                            break;
                    }
    
                }

                switch (solicitacao.listaWorkFlow[0].Chave) {
                    case $scope.WorkFlowEnum.SOLICITACAO:
                        solicitacao.track = 0;
                        break;
                    case $scope.WorkFlowEnum.ALMOXARIFADO:
                        solicitacao.track = 1;
                        break;
                    case $scope.WorkFlowEnum.COTACAO:
                        solicitacao.track = 2;
                        break;
                    case $scope.WorkFlowEnum.ANALISE:
                        solicitacao.track = 3;
                        break;
                    case $scope.WorkFlowEnum.APROVADA:
                        solicitacao.track = 3;
                        break;
                    case $scope.WorkFlowEnum.NAO_APROVADA:
                        solicitacao.track = 3;
                        break;
                    case $scope.WorkFlowEnum.COMPRA:
                        solicitacao.track = 4;
                        break;
                    case $scope.WorkFlowEnum.ENTREGUE:
                        solicitacao.track = 5;
                        break;
                    case $scope.WorkFlowEnum.RETIRADA:
                        solicitacao.track = 6;
                        break;
                    case $scope.WorkFlowEnum.CONCLUIDO:
                        solicitacao.track = 6;
                        break;
                }
            }
        );

        $scope.getSolicitacaoAuditoria(solicitacao);
    }

    $scope.getSolicitacaoAuditoria = (solicitacao) => {
        Solicitacao.getSolicitacaoAuditoria(solicitacao.IdSolicitacao, 
            (data) => {
                solicitacao.listaAuditoria = data.Instance;
            }
        );
    }

    $scope.getSolicitacaoItem = (solicitacao) => {
        var params = {IdSolicitacao: solicitacao.IdSolicitacao};
        Solicitacao.getSolicitacaoItem(params, 
            (data) => {
                solicitacao.listaInsumo = data.Instance;
                for (var i in solicitacao.listaInsumo) {
                    solicitacao.listaInsumo[i].IdCount = i;
                }
            }
        );
        if (!solicitacao.etapas)
            $scope.getEtapasConstrucao(solicitacao);
    }

    $scope.$on('getResumoCotacaoFornecedores', (event, args) => {
        $scope.getResumoCotacaoFornecedores(args.Solicitacao);
    });
    
    $scope.getResumoCotacaoFornecedores = (solicitacao) => {
        var params = {IdSolicitacao: solicitacao.IdSolicitacao};
        Cotacao.getResumoCotacaoFornecedores(params, 
            (data) => {
                solicitacao.listaCotacao = data.Instance;

                if (!solicitacao.construcao)
                    solicitacao.construcao = $scope.getObraById(solicitacao.IdConstrucao);
    
                if (!solicitacao.construcao.fornecedores)
                    $scope.getFornecedores(solicitacao);
                    
                $scope.getCotacaoALL(solicitacao);

                solicitacao.listaCotacao.forEach((l,i) => {
                    l.IdCount = i;
                    if (l.DataEmailEnviado) {
                        var data = new Date(l.DataEmailEnviado);
                        l.enviadoToolTip = `Enviado ${data.toLocaleDateString('pt-br',{year: 'numeric',month:'numeric',day:'numeric', hour:'numeric',minute:'numeric'})}`
                        setTimeout(()=>{
                            var elem = document.getElementById(`cotmailenv${l.IdCotacao}`);
                            elem.setAttribute('data-toggle','tooltip');
                            elem.setAttribute('data-placement','top');
                            elem.setAttribute('title',l.enviadoToolTip);
                            elem.style.color = '#000';
                            // elem.tooltip();
                        },10);
                    }
                    if (l.DataEmailAberto) {
                        var data = new Date(l.DataEmailAberto);
                        l.abertoToolTip = `Aberto ${data.toLocaleDateString('pt-br',{year: 'numeric',month:'numeric',day:'numeric', hour:'numeric',minute:'numeric'})}`
                        setTimeout(()=>{
                            var elem = document.getElementById(`cotmailabe${l.IdCotacao}`);
                            elem.setAttribute('data-toggle','tooltip');
                            elem.setAttribute('data-placement','top');
                            elem.setAttribute('title',l.abertoToolTip);
                            elem.style.color = '#000';
                            // elem.tooltip();
                        },10);
                    }
                    if (l.DataEmailRespondido) {
                        var data = new Date(l.DataEmailRespondido);
                        l.abertoToolTip = `Aberto ${data.toLocaleDateString('pt-br',{year: 'numeric',month:'numeric',day:'numeric', hour:'numeric',minute:'numeric'})}`
                        setTimeout(()=>{
                            var elem = document.getElementById(`cotmailok${l.IdCotacao}`);
                            elem.setAttribute('data-toggle','tooltip');
                            elem.setAttribute('data-placement','top');
                            elem.setAttribute('title',l.abertoToolTip);
                            elem.style.color = '#000';
                            // elem.tooltip();
                        },10);
                    }

                    $('[data-toggle="tooltip"]').tooltip();

                });

                    
    
            }
        );
    }

    $scope.getSolicitacaoSituacao = () => {
        Solicitacao.getSolicitacaoSituacao(
            (data) => {
                $scope.listaSolicitacaoSituacao = data.Instance;
            }
        );
    }

    $scope.adicionarSolicitacao = () => {
        if ($scope.listaSelecao.length > 1) {
            MsgBox.Atencao('Atenção!','Selecione apenas uma obra para adicionar a solicitação.',() => {
                setTimeout(() => {
                    document.getElementById('buttonOpenList').click()
                },100)
            });
            return;
        }
        $scope.openSolicitacao = true
        var item = {
            IdCount: $scope.listaSolicitacao.length + 1,
            IdSolicitacao: 0,
            IdConstrucao: $scope.construcao.Id,
            IdSolicitacaoWorkflow: 0,
            IdSolicitacaoSituacao: 0,
            IdClienteFuncionario: $scope.sessao.IdCliente,
            Texto: '',
            Data: CacheApp.getData($filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z')),
            Prioridade: 2,
            listaInsumo: [],
            Chave: $scope.WorkFlowEnum.SOLICITACAO,
            Novo: true,
            Editando: true,
            insumoOpen: true,
            open: true,
            HtmlEditarSolicitacao: $scope.getHtmlEditarSolicitacao()
        };

        item.etapas = $scope.getEtapasConstrucao(item);
        $scope.listaSolicitacao.unshift(item);
    }

    $scope.alterarSolicitacao = (item) => {
        item.editando = !item.editando;
        item.Selecionado = true;
    }

    $scope.cancelarSolicitacao = (item) => {
        $scope.openSolicitacao = false
        item.Editando = !item.Editando;
        if (item.Novo) {
            var idx = $scope.listaSolicitacao.indexOf(item);
            $scope.listaSolicitacao.splice(idx, 1);
        }
    }

    // $scope.selecionaObraSolicitacao = (item) => {
    //     item.IdConstrucao = item.ObraSelecionada.id
    //     item.etapas = $scope.getEtapasConstrucao(item)
    // }

    $scope.salvarSolicitacao = (solicitacao) => {
        if (solicitacao.Chave == $scope.WorkFlowEnum.SOLICITACAO) {
            if (solicitacao.Novo && solicitacao.listaInsumo.length == 0) {
                MsgBox.Atencao('Atenção!','A solicitação precisa conter pelo menos um item.',() => {});
                return;
            }
            if (solicitacao.listaInsumo.filter(s => s.Editando).length >0) {
                MsgBox.Atencao('Atenção!','É necessário que os itens estejam confirmados.',() => {});
                return;
            }
        }        

        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdConstrucao: solicitacao.IdConstrucao,
            IdSolicitacaoWorkflow: solicitacao.IdSolicitacaoWorkflow,
            IdSolicitacaoSituacao: solicitacao.IdSolicitacaoSituacao,
            IdClienteFuncionario: solicitacao.IdClienteFuncionario,
            Texto: solicitacao.Texto,
            Data: solicitacao.Data,
            Prioridade: solicitacao.Prioridade,
        }
        Solicitacao.setSolicitacao(params,
            (result) => {
                $scope.openSolicitacao = false
                solicitacao.IdSolicitacao = result.Instance.IdSolicitacao;
                var insumos = [];
                solicitacao.listaInsumo.forEach(
                    l => {
                        if (l.IdMaterial == 0)
                            insumos.push({
                                    IdConstrucao: solicitacao.IdConstrucao,
                                    Id: 0,
                                    Tipo: l.TipoMaterial.Id,
                                    Codigo: l.Codigo,
                                    Nome: l.Material,
                                    IdUnidade: l.IdUnidade,
                                    Valor: l.Valor,
                                    IdObraOrigem: l.IdConstrucao,
                                    Importado: l.Importado == 1
                                }         
                            );
                    }
                );

                if (insumos.length > 0)
                    Material.setListaMateriais(insumos, (result1) => {
                        $scope.salvarItensSolicitacao(solicitacao, result1.Instance);
                    });
                else
                    $scope.salvarItensSolicitacao(solicitacao, []);
            }
        );
    }

    $scope.salvarItensSolicitacao = (solicitacao, novosInsumos) => {
        var idx = 0;
        var itensSolicitacao = [];
        var idSol = solicitacao.IdSolicitacao;
        solicitacao.listaInsumo.forEach(
            l => {
                itensSolicitacao.push({
                        IdSolicitacaoItem: 0,
                        IdSolicitacao: idSol,
                        IdMaterial: l.IdMaterial == 0 ? novosInsumos[idx].IdMaterial : l.IdMaterial,
                        IdEtapa: l.IdEtapa,
                        IdComposicao: l.IdComposicao,
                        QuantidadeSolicitada: l.QuantidadeSolicitada
                    }
                );
                
                if (l.IdMaterial == 0) idx++;
            }
        );
                
        Solicitacao.setSolicitacaoListaItens(itensSolicitacao, (result12) => {
            $scope.inicializaPaginacao();
            $scope.getSolicitacoes();
        });
    }

    $scope.excluirSolicitacao = (solicitacao, insumo) => {
        MsgBox.Pergunta('Excluir Solicitação', ' Confirma?'
        , () => {
                Solicitacao.delSolicitacao(solicitacao.IdSolicitacao,
                    (result) => {
                        $scope.inicializaPaginacao();
                        $scope.getSolicitacoes();
                    }
                );
            }
        , () => {
        });
    }

    $scope.getHtmlEditarSolicitacao = () => {
        return `
            <form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formSolicitacao">
                <div class="form-group">
                    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">
                        <div>
                            <label>Data Limite: </label>
                            <input type="date" class="form-control" ng-model="solicitacao.Data" required datasafari />
                        </div>
                    </div>
                    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">
                        <div>
                            <label>Prioridade: </label> <br />
                            <div class="btn-group" data-toggle="buttons"> 
                                <label class="btn" ng-class="{'active btn-success': solicitacao.Prioridade == 1, 'btn-default': solicitacao.Prioridade != 1}" ng-click="solicitacao.Prioridade = 1"> 
                                    <input type="radio" name="bdiNF" id="optBAI" value="1" autocomplete="off" ng-class="{'checkd': solicitacao.Prioridade == 1}"> BAIXA 
                                </label> 
                                <label class="btn" ng-class="{'active btn-warning': solicitacao.Prioridade == 2, 'btn-default': solicitacao.Prioridade != 2}" ng-click="solicitacao.Prioridade = 2"> 
                                    <input type="radio" name="bdiNF" id="optMED" value="0" autocomplete="off" ng-class="{'checked': solicitacao.Prioridade == 2}"> MÉDIA 
                                </label> 
                                <label class="btn" ng-class="{'active btn-danger': solicitacao.Prioridade == 3, 'btn-default': solicitacao.Prioridade != 3}" ng-click="solicitacao.Prioridade = 3"> 
                                    <input type="radio" name="bdiNF" id="optALT" value="0" autocomplete="off" ng-class="{'checked': solicitacao.Prioridade == 3}"> ALTA 
                                </label> 
                            </div> 
                        </div> 
                    </div>
                    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12 text-right">
                        <label>&nbsp</label> <br />
                        <itemsalvar ng-click="(!formSolicitacao.$invalid && salvarSolicitacao(solicitacao)); $event.stopPropagation();"></itemsalvar>
                        <itemcancelar ng-click="cancelarSolicitacao(solicitacao); $event.stopPropagation();"></itemcancelar>
                    </div>
                </div>
            </form>
        `
    }

    $scope.pdfSolicitacaoItem = (solicitacao) => {
        var obra = $scope.getObraById(solicitacao.IdConstrucao);
        var cabecalho = {
            Avatar: obra.ContaAvatar,
            Obra: obra.Titulo,
            Conta: obra.Conta,
            Moeda: obra.Moeda,
            DescricaoObra: `Local: ${obra.Endereco}, ${obra.Numero}. ${obra.Complemento} ${obra.Bairro} ${obra.Cidade} - ${obra.Estado}
                            Telefone: ${obra.Telefone}
                            Responsável: ${obra.Contato}`
        };

        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdConstrucao: solicitacao.IdConstrucao,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Solicitacao.pdfSolicitacaoItem(params,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.xlsSolicitacaoItem = (solicitacao) => {
        var obra = $scope.getObraById(solicitacao.IdConstrucao);
        var cabecalho = {
            Avatar: obra.ContaAvatar,
            Obra: obra.Titulo,
            Conta: obra.Conta,
            Moeda: obra.Moeda,
            DescricaoObra: `Local: ${obra.Endereco}, ${obra.Numero}. ${obra.Complemento} ${obra.Bairro} ${obra.Cidade} - ${obra.Estado}
                            Telefone: ${obra.Telefone}
                            Responsável: ${obra.Contato}`
        };

        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdConstrucao: solicitacao.IdConstrucao,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Solicitacao.xlsSolicitacaoItem(params,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    /* EDITAR INSUMO */

    $scope.adicionarInsumo = (solicitacao) => {
        if (!solicitacao.IdConstrucao) {
            MsgBox.Atencao('Atenção!','Selecione a obra para efetuar a solicitação.',() => {});
            return;
        }
        var item = {
            IdCount: solicitacao.listaInsumo.length + 1,
            IdSolicitacaoItem: 0,
            IdSolicitacao: 0,
            IdConstrucao: solicitacao.IdConstrucao,
            IdMaterial: 0,
            Codigo: '',
            Unidade: '',
            Material: '',
            QuantidadeSolicitada: 0,
            QuantidadeAlocada: 0,
            Novo: true,
            Editando: true,
            HtmlEditarInsumo: $scope.getHtmlEditarInsumo()
        };

        solicitacao.listaInsumo.unshift(item);
    }

    $scope.alterarInsumo = (solicitacao,insumo) => {
        insumo.HtmlEditarInsumo = $scope.getHtmlEditarInsumo();
        $scope.getListaComposicao(solicitacao,insumo);

        insumo.Selecionado = true;
        insumo.Editando = !insumo.Editando;
    }

    $scope.cancelarInsumo = (solicitacao, insumo) => {
        insumo.Editando = !insumo.Editando;
        if (insumo.Novo) {
            var idx = solicitacao.listaInsumo.indexOf(insumo);
            solicitacao.listaInsumo.splice(idx, 1);
        }
    }

    $scope.getEtapasConstrucao = (solicitacao) => {
        solicitacao.etapas = [];
        Construcao.getEtapasConstrucao(solicitacao.IdConstrucao,
            (data) => {
                solicitacao.etapas = data.Instance;
            });
    }

    $scope.getListaComposicao = (solicitacao,insumo) => {
        if (!insumo.IdEtapa) return;

        for (var i in solicitacao.etapas)
            if (solicitacao.etapas[i].Id == insumo.IdEtapa) {
                insumo.Etapa = solicitacao.etapas[i].Descricao;
                break;
            }

        Material.getListaMaterialAvanco(
            solicitacao.IdConstrucao,
            insumo.IdEtapa,
            '',
            (data) => {
                solicitacao.composicoes = data.Instance;
            }
        );
    }

    $scope.changeListaComposicao = (solicitacao,insumo) => {
        for (var i in solicitacao.composicoes)
            if (solicitacao.composicoes[i].Id == insumo.IdComposicao) {
                insumo.Composicao = solicitacao.composicoes[i].Nome;
                break;
            }
    }

    $scope.getTipoMaterial = () => {
        Material.getTipoMaterial(
            (data) => {
                $scope.listaTipoMaterial = data.Instance;
            });
    }

    $scope.getListaUnidades = () => {
        Material.getListaUnidades(
            (data) => {
                $scope.listaUnidade = data.Instance;
            }
        );
    }

    $scope.salvarInsumo = (solicitacao, insumo) => {
        insumo.Editando = !insumo.Editando;

        if (solicitacao.IdSolicitacao == 0) return;

        $scope.salvarItemSolicitacao(solicitacao,insumo);
    }

    $scope.excluirInsumo = (solicitacao, insumo) => {
        MsgBox.Pergunta(insumo.Material, ' Confirma exclusão?'
        , () => {
                Solicitacao.delSolicitacaoItem(insumo.IdSolicitacaoItem,
                    (result) => {
                        var idx = solicitacao.listaInsumo.indexOf(insumo);
                        solicitacao.listaInsumo.splice(idx, 1);
                        $scope.atualizaItemFornecedores(solicitacao);
                    }
                );
            }
        , () => {
        });
    }

    $scope.atualizaItemFornecedores = (solicitacao) => {
        if (solicitacao.listaCotacao && solicitacao.listaCotacao.length > 0) {
            $scope.atualizaCotacaoALL(solicitacao);
        }
        $scope.getSolicitacaoAuditoria(solicitacao);
    }


    $scope.salvarItemSolicitacao = (solicitacao, novoInsumo) => {

        var itemSolicitacao = {
            IdSolicitacaoItem: novoInsumo.IdSolicitacaoItem ? novoInsumo.IdSolicitacaoItem : 0,
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdMaterial: novoInsumo.IdMaterial,
            IdEtapa: novoInsumo.IdEtapa,
            IdComposicao: novoInsumo.IdComposicao,
            QuantidadeSolicitada: novoInsumo.QuantidadeSolicitada
        };

        if (!novoInsumo.Selecionado || novoInsumo.IdMaterial == 0) {
            var insumo = {
                Id: 0,
                Tipo: novoInsumo.TipoMaterial.Id,
                Codigo: novoInsumo.Codigo,
                Nome: novoInsumo.Material,
                IdUnidade: novoInsumo.IdUnidade,
                Valor: novoInsumo.Valor,
                IdObraOrigem: novoInsumo.IdConstrucao,
                Importado: novoInsumo.Importado == 1
        // Valor: 0.00
            };
    
            Material.setMaterial(solicitacao.construcao.Id, insumo,
                (result) => {
                    itemSolicitacao.IdMaterial = result.Instance[0].IdMaterial;
                    Solicitacao.setSolicitacaoItem(itemSolicitacao, 
                        (result1) => {
                            novoInsumo.IdSolicitacaoItem = result1.Instance.IdSolicitacaoItem;
                            $scope.atualizaItemFornecedores(solicitacao);
                        }
                    );
                }
            );
        }
        else
            Solicitacao.setSolicitacaoItem(itemSolicitacao, 
                (result1) => {
                    novoInsumo.IdSolicitacaoItem = result1.Instance.IdSolicitacaoItem;
                    $scope.atualizaItemFornecedores(solicitacao);
                }
            );
    }
    
    $scope.setUnidadeSigla = (insumo) => {
        for (var i in $scope.listaUnidade)
            if ($scope.listaUnidade[i].Id == insumo.IdUnidade) {
                insumo.Unidade = $scope.listaUnidade[i].Sigla;
                break;
            }
    }

    /* override getLista(texto)  */
    $scope.getListaInsumo = (texto, item) => {
        item.IdMaterial = 0;
        item.Selecionado = false;

        var params = {
            idConstrucao: 0, //$scope.construcao ? $scope.construcao.Id : item.IdConstrucao,
            nome: texto,
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined
        }
        Material.getListaBasePropria(params,
            (data) => {
                $scope.listaInsumo = [];
                var materiais = data.Instance;
                for (var i in materiais)
                    $scope.listaInsumo.push(materiais[i]);

                if ($scope.listaInsumo.length == 0)
                    item.Selecionado = false;

                $scope.listaInsumo.sort(
                    (a, b) => {
                        return a.IdConstrucao == item.IdConstrucao ? -1 : (a.IdConstrucao > b.IdConstrucao ? 0 : 1)
                    }
                );
    
            });

    }

    /* override clickAdd()  */
    $scope.novoInsumo = () => {
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoInsumo = (selecionado, insumo) => {
        insumo.IdMaterial = insumo.IdConstrucao == selecionado.IdConstrucao ? selecionado.Id : 0;
        insumo.Codigo = selecionado.Codigo;
        insumo.Material = selecionado.Nome;
        insumo.Nome = selecionado.Nome;
        insumo.Unidade = selecionado.UnidadeSigla;
        insumo.TipoMaterial = {Id: selecionado.Tipo};
        insumo.IdUnidade = selecionado.IdUnidade;

        insumo.Selecionado = true;
    }

    $scope.getHtmlEditarInsumo = () => {
        return '' +
            '<form role="form" class="form" name="formInsumo">' +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '			    <div class="col-lg-7 col-md-7 col-sm-7 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Insumo</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Insumo\'"' +
            '                       ddc-mensagemvazio="\'NENHUM INSUMO ENCONTRADO\'"' +
            '                       ddc-showcodigo="true"' +
            '                       ddc-showvalor="true"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="construcao"' +
            '                       ddc-item="insumo"' +
            '                       ddc-lista="listaInsumo"' +
            '                       set-selecionado="setSelecionadoInsumo(selecionado,insumo)"' +
            '                       get-lista="getListaInsumo(texto,insumo)"' +
            '                       click-add="novoInsumo()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Quantidade {{!insumo.Unidade ? "" : ("("+insumo.Unidade+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Quantidade" ng-model="insumo.QuantidadeSolicitada" ui-number-mask="2" required>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group" ng-show="!insumo.Selecionado">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <label>Tipo Insumo</label>'+
            '                   <select class="form-control"' +
            '                       ng-model="insumo.TipoMaterial"' +
            '                       ng-options="tipo.Descricao for tipo in listaTipoMaterial track by tipo.Id" ng-required="!insumo.Selecionado">' +
            '                       <option style="display:none" value=""> Selecione o tipo </option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <br class="showMobile" />' +
            '                   <label>Unidade</label>'+
            '	                <select class="form-control" ng-model="insumo.IdUnidade" ng-init="insumo.IdUnidade = insumo.IdUnidade + \'\'" ng-change="setUnidadeSigla(insumo)" ng-required="!insumo.Selecionado">' +
            '	                    <option value="" selected disabled> Unidade de referência </option>' +
            '	                    <option ng-repeat="unidade in listaUnidade" value="{{unidade.Id}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <br class="showMobile" />' +
            '                   <label>Código</label>'+
            '	                <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="insumo.Codigo"/>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '                   <label>Etapa</label>' +
            `                   <select class="form-control" ng-model="insumo.IdEtapa" ng-init="insumo.IdEtapa = insumo.IdEtapa ? insumo.IdEtapa + '' : ''" ng-change="getListaComposicao(solicitacao,insumo)" >` +
            '                       <option value="" selected disabled> Selecione a Etapa </option>' +
            `                       <option ng-repeat="etapa in solicitacao.etapas" value="{{etapa.Id}}">{{etapa.Ordem + ' ' + etapa.Descricao}}</option>` +
            '                   </select>' +
            '                   <br />' +
            '               </div>' +
            '           </div>' +
            '           <div class="row" ng-show="insumo.IdEtapa" ng-disabled="solicitacao.composicoes && solicitacao.composicoes.length > 0">' +
            '               <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '                   <label>Composição</label>' +
            `                   <select class="form-control" ng-disabled="!solicitacao.composicoes" ng-model="insumo.IdComposicao" ng-init="insumo.IdComposicao = insumo.IdComposicao ? insumo.IdComposicao + '' : ''" ng-change="changeListaComposicao(solicitacao,insumo)">` +
            '                       <option value="" selected disabled> Selecione a Composição </option>' +
            `                       <option ng-repeat="composicao in solicitacao.composicoes" value="{{composicao.Id}}">{{composicao.Ordem + ' ' + composicao.Nome}}</option>` +
            '                   </select>' +
            '                   <br />' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-click="!formInsumo.$invalid && salvarInsumo(solicitacao, insumo); $event.stopPropagation();" ></itemsalvar>' +
            '           <itemcancelar ng-click="cancelarInsumo(solicitacao, insumo); $event.stopPropagation();"></itemcancelar>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }

    /* FIM EDITAR INSUMO */

    /* INICIO WORKFLOW */

    $scope.atenderWorkflow = (solicitacao) => {
        MsgBox.Pergunta(solicitacao.HintLabel, 'Confirma?'
        , () => {
                var solicitacaoWorkflow = {
                    IdSolicitacao: solicitacao.IdSolicitacao,
                    IdConstrucao: solicitacao.IdConstrucao,
                    IdSolicitacaoWorkflow: 0,
                    IdSolicitacaoSituacao: $scope.getIdSolicitacaoWorkflow(solicitacao.ChaveNextWorkflow),
                    IdClienteFuncionario: $scope.sessao.IdCliente,
                    Texto: 'Atendendo Solicitação'
                }
                Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                    (data) => {
                        $scope.getSolicitacoesRefresh(solicitacao,false)
                        // $scope.inicializaPaginacao();
                        // $scope.getSolicitacoes();
                    }
                );
            }
        , () => {
        });
    }
    
    $scope.cancelarWorkflow = (solicitacao) => {
        swal({
            title: `Cancelar Solicitação`,
            html: '<textarea type="text" class="form-control" placeholder="Observação" id="Observacao" rows="4"></textarea>',
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Salvar',
            cancelButtonText: "Cancelar",
          }).then((result) => {
            if (result.value) {
                var texto = $('#Observacao').val();

                var solicitacaoWorkflow = {
                    IdSolicitacao: solicitacao.IdSolicitacao,
                    IdConstrucao: solicitacao.IdConstrucao,
                    IdSolicitacaoWorkflow: 0,
                    IdSolicitacaoSituacao: $scope.getIdSolicitacaoWorkflow($scope.WorkFlowEnum.CANCELADO),
                    IdClienteFuncionario: $scope.sessao.IdCliente,
                    Texto: texto
                }

                Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                    (data) => {
                        $scope.inicializaPaginacao();
                        $scope.getSolicitacoes();
                    }
                );
            }
          });

    }
    
    $scope.finalizarWorkflow = (solicitacao) => {
        var aprovacao = solicitacao.ChaveNextWorkflow == $scope.WorkFlowEnum.ANALISE;

        if (!aprovacao 
            && solicitacao.Chave == $scope.WorkFlowEnum.COTACAO 
            && (!solicitacao.CotacaoFinal || solicitacao.CotacaoFinal.length == 0)) {
                MsgBox.Atencao('Atenção!','Não há item selecionado para aprovação.',() => {});
                return;
        }

        if (solicitacao.Chave == $scope.WorkFlowEnum.ANALISE
            && !solicitacao.Aprovacao.some(cot => cot.Itens.some(i => i.aprovado)) ) {
                MsgBox.Atencao('Atenção!','Não há item selecionado para aprovar a compra.',() => {});
                return;
        }

        var checkLancamento = '';
        if (solicitacao.ChaveNextWorkflow == $scope.WorkFlowEnum.COMPRA) {
            // var acessos = $scope.construcao ? $scope.construcao.Acessos : $scope.getObraById(solicitacao.IdConstrucao).Acessos;
            // if (acessos.indexOf('SET_DEBITO') >= 0)
            checkLancamento = '<br><input type="checkbox" name="lancaNF" id="lancaNF" checked> Efetuar Lançamento Financeiro da Compra';
        }


        swal({
            title: solicitacao.HintLabel, //aprovacao ? 'Compra Aprovada' : `Enviar ${solicitacao.Situacao}`,
            html: '<textarea type="text" class="form-control" placeholder="Observação" id="Observacao" rows="4"></textarea>' + checkLancamento,
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Salvar',
            cancelButtonText: "Cancelar",
          }).then((result) => {
            if (result.value) {
                var texto = $('#Observacao').val();

                var solicitacaoWorkflow = {
                    IdSolicitacao: solicitacao.IdSolicitacao,
                    IdConstrucao: solicitacao.IdConstrucao,
                    IdSolicitacaoWorkflow: solicitacao.IdSolicitacaoWorkflow,
                    IdSolicitacaoSituacao: aprovacao ? $scope.getIdSolicitacaoWorkflow($scope.WorkFlowEnum.APROVADA) : solicitacao.IdSolicitacaoSituacao,
                    IdClienteFuncionario: $scope.sessao.IdCliente,
                    Texto: texto
                }

                if (solicitacao.ChaveNextWorkflow == $scope.WorkFlowEnum.COMPRA)
                    solicitacaoWorkflow.isLancamentoFinanceiro = document.getElementById('lancaNF').checked;

                if (!aprovacao 
                    && solicitacao.Chave == $scope.WorkFlowEnum.COTACAO 
                    && (solicitacao.listaInsumo.some(li => !solicitacao.CotacaoFinal.some(cf => cf.IdSolicitacaoItem == li.IdSolicitacaoItem)) )) {
                        MsgBox.Pergunta('Atenção!','A lista possui itens não selecionados, deseja criar uma nova cotação com estes itens?',
                            () => {
                                Solicitacao.setSolicitacaoItensNaoCotados({IdSolicitacao: solicitacaoWorkflow.IdSolicitacao},
                                    (data) => {
                                        Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                                            (data) => {
                                                $scope.getSolicitacoesRefresh(solicitacao,true)
                                                // $scope.inicializaPaginacao();
                                                // $scope.getSolicitacoes();
                                            }
                                        );
                                    }
                                );
                            },
                            () => {
                                Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                                    (data) => {
                                        $scope.getSolicitacoesRefresh(solicitacao,false)
                                        // $scope.inicializaPaginacao();
                                        // $scope.getSolicitacoes();
                                    }
                                );
                            },
                        )
                } else 
                    if(solicitacao.Chave == $scope.WorkFlowEnum.ANALISE
                        && solicitacao.Aprovacao.some(cot => cot.Itens.some(i => !i.aprovado) ))
                        MsgBox.Pergunta('Atenção!','A lista possui itens não selecionados, deseja criar uma nova aprovação com estes itens?',
                            () => {
                                // var ids = solicitacao.Aprovacao.filter(cot => cot.Itens.some(i => !i.aprovado) ).map(cot => cot.Itens.filter(coi => coi.aprovado).map(coi => coi.IdSolicitacaoItem) );
                                var ids = []
                                solicitacao.Aprovacao.forEach(cot => {
                                    cot.Itens.filter(i => !i.aprovado).forEach(coi => {
                                        ids.push(coi.IdSolicitacaoItem)
                                    })
                                })

                                Solicitacao.setSolicitacaoItensNaoCotados({IdSolicitacao: solicitacaoWorkflow.IdSolicitacao, IdsSolicitacaoItem: ids},
                                    (data) => {
                                        Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                                            (data) => {
                                                $scope.getSolicitacoesRefresh(solicitacao,true)
                                                // $scope.inicializaPaginacao();
                                                // $scope.getSolicitacoes();
                                            }
                                        );
                                    }
                                );
                            },
                            () => {
                                Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                                    (data) => {
                                        $scope.getSolicitacoesRefresh(solicitacao,false)
                                        // $scope.inicializaPaginacao();
                                        // $scope.getSolicitacoes();
                                    }
                                );
                            },
                        )
                    else {
                        // alert('AQUI!!!')
                        Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                            (data) => {
                                // if (solicitacaoWorkflow.isLancamentoFinanceiro) {
                                if (solicitacao.Chave == $scope.WorkFlowEnum.COMPRA) {
                                    var cotacoes = []
                                    solicitacao.Aprovacao.forEach(ap => {
                                        cotacoes.push({
                                            IdConstrucao: solicitacaoWorkflow.IdConstrucao,
                                            IdCotacao: ap.IdCotacao,
                                            DataVencimento: ap.DataVencimento,
                                            DataEntrega: ap.DataEntrega
                                        })
                                    })
            
                                    Cotacao.setDataEntregaVencimentoCotacao(cotacoes, (data) => {
                                        $scope.getSolicitacoesRefresh(solicitacao,false)
                                        // $scope.inicializaPaginacao()
                                        // $scope.getSolicitacoes()
                                    })
                                }
                                else {
                                    $scope.getSolicitacoesRefresh(solicitacao,false)
                                    // $scope.inicializaPaginacao()
                                    // $scope.getSolicitacoes()
                                }
                            }
                        )
                        // Cotacao.setDataEntregaVencimentoCotacao(cotacoes, (data) => {
                        //     // alert('foi!')
                        // })

                    }
            }
          });
    }

    $scope.naoAprovarSolicitacao = (solicitacao) => {

        swal({
            title: `Compra não Aprovada`,
            html: '<textarea type="text" class="form-control" placeholder="Observação" id="Observacao" rows="4"></textarea>',
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Salvar',
            cancelButtonText: "Cancelar",
          }).then((result) => {
            if (result.value) {
                var texto = $('#Observacao').val();

                var solicitacaoWorkflow = {
                    IdSolicitacao: solicitacao.IdSolicitacao,
                    IdConstrucao: solicitacao.IdConstrucao,
                    IdSolicitacaoWorkflow: solicitacao.IdSolicitacaoWorkflow,
                    IdSolicitacaoSituacao: $scope.getIdSolicitacaoWorkflow($scope.WorkFlowEnum.NAO_APROVADA),
                    IdClienteFuncionario: $scope.sessao.IdCliente,
                    Texto: texto
                }

                Solicitacao.setSolicitacaoWorkflow(solicitacaoWorkflow,
                    (data) => {
                        $scope.getSolicitacoesRefresh(solicitacao,false)
                        // $scope.inicializaPaginacao();
                        // $scope.getSolicitacoes();
                    }
                );
            }
          });
    }

    $scope.getIdSolicitacaoWorkflow = (chave) => {
        var id = 0;
        $scope.listaSolicitacaoSituacao.every(s => {
            id = s.Id;
            return !(s.Chave == chave);
        });
        return id;
    }

    /* FIM WORKLOW */

    /* INICIO ALOCACAO */

    $scope.getAlocacaoInsumo = (insumo) => {
        insumo.alocacaoOpen = !insumo.alocacaoOpen;
        $scope.getListaAlocacao(insumo, undefined);
    }

    $scope.setAlocacaoInsumo = (insumo,alocacao) => {
        Almoxarifado.setAlocarInsumoAlmoxarifado(alocacao, 
            (data) => {
                if (data.Code == 0) {
                    $scope.getListaAlocacao(insumo, null);
                    $scope.atualizaSolicitacaoItem(insumo);
                }
                else
                    MsgBox.Atencao('Atenção!',data.Description,() => {});
            }
        );
    }

    $scope.getListaAlocacao = (insumo, callBack) => {
        if (callBack && insumo.listaAlocacao && insumo.listaAlocacao.length > 0) 
            callBack();
        else {
            var params = {
                IdAlmoxarifado: insumo.IdAlmoxarifado, 
                IdSolicitacaoItem: insumo.IdSolicitacaoItem
            };
            Almoxarifado.getAlocarInsumosAlmoxarifado(params, 
                (data) => {
                    insumo.listaAlocacao = data.Instance ? data.Instance : [];
                    for (var i in insumo.listaAlocacao) {
                        insumo.listaAlocacao[i].IdCount = i;
                        insumo.listaAlocacao[i].DataHora = CacheApp.getData($filter("date")(insumo.listaAlocacao[i].DataHora, 'yyyy-MM-ddT03:05:00Z'));
                    }
                    if (callBack)
                        callBack();
                }
            );
        }
    }

    $scope.adicionarAlocacao = (solicitacao,insumo) => {
        $scope.getListaAlocacao(insumo, () => {
            var item = {
                IdCount: insumo.listaAlocacao.length + 1,
                IdAlmoxarifado: insumo.IdAlmoxarifado,
                IdSolicitacaoItem: insumo.IdSolicitacaoItem,
                IdRetirada: 0,
                IdEtapa: insumo.IdEtapa ? insumo.IdEtapa.toString() : '',
                IdComposicao: insumo.IdComposicao ? insumo.IdComposicao.toString() : '',
                Quantidade: insumo.QuantidadeSolicitada,
                Unidade: insumo.Unidade,
                Novo: true,
                Editando: true,
                HtmlEditarAlocacao: $scope.getHtmlAlocacao()
            };

            if (insumo.IdEtapa)
                $scope.getListaComposicao(solicitacao,insumo);

            insumo.listaAlocacao.unshift(item);
            insumo.alocacaoOpen = true;
        });
    }

    $scope.alterarAlocacao = (solicitacao,alocacao) => {
        alocacao.HtmlEditarAlocacao = $scope.getHtmlAlocacao();
        $scope.getListaComposicao(solicitacao,alocacao);

        // insumo.Selecionado = true;
        alocacao.Editando = !alocacao.Editando;
    }

    $scope.cancelarAlocacao = (insumo, alocacao) => {
        alocacao.Editando = !alocacao.Editando;
        if (alocacao.Novo) {
            var idx = insumo.listaAlocacao.indexOf(alocacao);
            insumo.listaAlocacao.splice(idx, 1);
        }
    }

    $scope.excluirAlocacao = (insumo, alocacao) => {
        MsgBox.Pergunta(insumo.Material, ' Confirma exclusão da quantidade alocada?'
        , () => {
                var params = {
                    IdAlmoxarifado: insumo.IdAlmoxarifado,
                    IdRetirada: alocacao.IdRetirada
                };
                Almoxarifado.delAlocarInsumoAlmoxarifado(params, 
                    (data) => {
                        insumo.listaAlocacao = data.Instance ? data.Instance : [];
                        for (var i in insumo.listaAlocacao) {
                            insumo.listaAlocacao[i].IdCount = i;
                            insumo.listaAlocacao[i].Data = CacheApp.getData($filter("date")(insumo.listaAlocacao[i].Data, 'yyyy-MM-ddT03:05:00Z'));
                        }
                        $scope.atualizaSolicitacaoItem(insumo);
                    }
                );
            }
        , () => {
        });
    }

    $scope.atualizaSolicitacaoItem = (insumo) => {
        var params = {
            IdSolicitacao: insumo.IdSolicitacao,
            IdSolicitacaoItem: insumo.IdSolicitacaoItem
        };

        Solicitacao.getSolicitacaoItem(params, 
            (data) => {
                var item = data.Instance[0];
                insumo.Codigo = item.Codigo;
                insumo.Material = item.Material;
                insumo.QuantidadeSolicitada = item.QuantidadeSolicitada;
                insumo.QuantidadeAlocada = item.QuantidadeAlocada;
                insumo.Almoxarife = item.Almoxarife;
            }
        );
    }

    $scope.getHtmlAlocacao = () => {
        return '<br />' +
            '<form class="form col-lg-12 col-md-12 col-sm-12 center-block" name="formCanteiro">' +
            '    <div class="form-group">' +
            '        <div class="row">' +
            '            <div class="col-md-10">' +
            '                <div class="showMobile"><br /></div>' +
            '                <label>Etapa:</label>'+
            `                <select class="form-control" ng-model="alocacao.IdEtapa" ng-init="alocacao.IdEtapa = alocacao.IdEtapa ? alocacao.IdEtapa + '' : '' " ng-change="getListaComposicao(solicitacao,alocacao)" autofocus>` +
            '                    <option value="" selected disabled> Selecione a Etapa </option>' +
            '                    <option ng-repeat="etapa in solicitacao.etapas" value="{{etapa.Id}}">{{etapa.Ordem + \' \' + etapa.Descricao}}</option>' +
            '                </select>' +
            '            </div>' +
            '       </div>' +
            '    </div>' +
            '    <div class="form-group">' +
            '        <div class="row">' +
            '            <div class="col-md-10">' +
            '                <div class="showMobile"><br /></div>' +
            '                <label>Composição:</label>'+
            `                <select class="form-control" ng-disabled="!solicitacao.composicoes" ng-init="alocacao.IdComposicao = alocacao.IdComposicao ? alocacao.IdComposicao + '' : '' " ng-model="alocacao.IdComposicao">` +
            '                    <option value="" selected disabled> Selecione a Composição </option>' +
            '                    <option ng-repeat="composicao in solicitacao.composicoes" value="{{composicao.Id}}">{{composicao.Ordem + \' \' + composicao.Nome}}</option>' +
            '                </select>' +
            '            </div>' +
            '        </div>' +
            '    </div>' +
            '    <div class="form-group">' +
            '        <div class="row">' +
            '           <div class="col-md-4">' +
            '               <div class="showMobile"><br /></div>' +
            '               <label>Quantidade:</label>'+
            '               <div class="input-group">' +
            '                   <input type="text" class="form-control" placeholder="Quantidade" ng-model="alocacao.Quantidade" ui-number-mask="2" required>' +
            '                   <span class="input-group-addon">' +
            '                       {{insumo.Unidade}}' +
            '                   </span>' +
            '               </div>' +
            '           </div>' +
            '           <div class="col-md-6 text-right">' +
            '	            <itemsalvar ng-click="!formCanteiro.$invalid && setAlocacaoInsumo(insumo,alocacao); $event.stopPropagation();"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarAlocacao(insumo,alocacao); $event.stopPropagation();"></itemcancelar>' +
            '           </div>' +
            '        </div>' +
            '    </div>' +
            '</form>';
    }

    /* FIM ALOCACAO */

    /* EDITAR COTACAO */

    $scope.adicionarCotacaoFornecedor = (solicitacao) => {
        if (!solicitacao.listaCotacao)
            solicitacao.listaCotacao = [];
        if (!solicitacao.construcao)
            solicitacao.construcao = $scope.getObraById(solicitacao.IdConstrucao);

        if (!solicitacao.construcao.fornecedores)
            $scope.getFornecedores(solicitacao);

        var item = {
            IdCount: solicitacao.listaCotacao.length + 1,
            IdCotacao: 0,
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdFornecedor: 0,
            Prazo: 0,
            Frete: 0,
            Texto: '',
            FormaPagamento: '',
            Fornecedor: {Tipo: 0, TipoPessoa: 1},
            Novo: true,
            Editando: true,
            HtmlEditarFornecedor: $scope.getHtmlEditarFornecedor()
        };

        solicitacao.listaCotacao.unshift(item);
    }

    $scope.alterarCotacaoFornecedor = (cotacao) => {
        cotacao.HtmlEditarFornecedor = $scope.getHtmlEditarFornecedor();

        cotacao.Selecionado = true;
        cotacao.Editando = !cotacao.Editando;
    }

    $scope.cancelarCotacaoFornecedor = (solicitacao, cotacao) => {
        cotacao.Editando = !cotacao.Editando;
        if (cotacao.Novo) {
            var idx = solicitacao.listaCotacao.indexOf(cotacao);
            solicitacao.listaCotacao.splice(idx, 1);
        }
    }

    $scope.excluirCotacaoFornecedor = (solicitacao, cotacao) => {
        MsgBox.Pergunta(cotacao.RazaoSocial, ' Confirma exclusão da cotação do fornecedor?'
        , () => {
                Cotacao.delCotacao(cotacao,
                    (data) => {
                        $scope.getResumoCotacaoFornecedores(solicitacao);
                    }
                );
            }
        , () => {
        });
    }

    $scope.salvarCotacaoFornecedor = (solicitacao, cotacao) => {

        var novaCotacao = {
            IdCotacao: cotacao.IdCotacao,
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdFornecedor: cotacao.Fornecedor ? cotacao.Fornecedor.IdFornecedor : cotacao.IdFornecedor,
            Prazo: cotacao.Prazo,
            Frete: cotacao.Frete,
            Texto: cotacao.Texto,
            FormaPagamento: cotacao.FormaPagamento
        }

        if (!cotacao.Selecionado) {
            var novoFornecedor = {
                IdFornecedor: 0,
                IdCliente: solicitacao.construcao.IdClienteDono,
                Tipo: cotacao.Fornecedor.Tipo,
                TipoPessoa: cotacao.Fornecedor.TipoPessoa,
                Avatar: ``,
                Cnpj: cotacao.Fornecedor.Cnpj,
                RazaoSocial: cotacao.RazaoSocial,
                NomeFantasia: ``,
                CEP: ``,
                Numero: ``,
                IdPais: $scope.construcao ? $scope.construcao.IdConfiguracao : solicitacao.construcao.IdConfiguracao,
                IdEstado: ``,
                IdCidade: ``,
                Endereco: ``,
                Email: cotacao.Fornecedor.Email,
                Responsavel: ``,
                Telefone1: cotacao.Fornecedor.Celular,
                Telefone2: ``,
            }
            Fornecedor.setFornecedor(novoFornecedor,
                (result) => {
                    novaCotacao.IdFornecedor = result.Instance.IdFornecedor;
                    Cotacao.setCotacao(novaCotacao, 
                        (data) => {
                            $scope.getResumoCotacaoFornecedores(solicitacao);
                        }
                    );
                }
            );
    
        }
        else
            Cotacao.setCotacao(novaCotacao, 
                (data) => {
                    $scope.getResumoCotacaoFornecedores(solicitacao);
                }
            );
    }

    $scope.getFornecedores = (solicitacao) => {
        solicitacao.construcao.fornecedoresAll = 
            $scope.ListaFornecedorCliente.filter(
                f => f.IdClienteDono == solicitacao.construcao.IdClienteDono
            )[0].Lista;
    }

    $scope.getFornecedoresAll = (IdClienteDono, callBackFunction) => {
        if (!$scope.ListaFornecedorCliente)
            $scope.ListaFornecedorCliente = [];

        if ($scope.ListaFornecedorCliente.some(f => f.IdClienteDono == IdClienteDono)) {
            callBackFunction();
            return;
        }

        $scope.ListaFornecedorCliente.push(
            {
                IdClienteDono: IdClienteDono
            }
        )

        var params = {
            IdClienteDono: IdClienteDono
        };

        Fornecedor.getFornecedores(params,
            (data) => {
                $scope.ListaFornecedorCliente.filter(f => f.IdClienteDono == params.IdClienteDono)[0].Lista = data.Instance;
                callBackFunction();
            });
    }

    $scope.CopyUrl = (cotacao) => {
        $scope.CopyText(cotacao.Url);
    }    
    
    /* override getLista(texto)  */
    $scope.getListaFornecedor = (texto, cotacao, solicitacao) => {
        cotacao.Selecionado = false;
        $scope.listaFornecedor = $filter('filter')(solicitacao.construcao.fornecedoresAll, {RazaoSocial: texto});
    }

    /* override clickAdd()  */
    $scope.novoFornecedor = () => {
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoFornecedor = (selecionado, cotacao) => {
        cotacao.Fornecedor = selecionado;
        cotacao.Selecionado = true;
    }

   $scope.exibirFornecedores = (solicitacao) => {
        $scope.listaFornecedor = solicitacao.construcao.fornecedoresAll;
        $scope.dadosBoxFornecedor = {
            ListaFornecedor: solicitacao.construcao.fornecedoresAll.filter(f => solicitacao.listaCotacao.filter(c => c.IdFornecedor == f.IdFornecedor).length == 0),
            Solicitacao: solicitacao
        }
        $('#BoxFornecedor').modal('show');
    }

    $scope.getHtmlEditarFornecedor = () => {
        return '' +
            '<form role="form" class="form" name="formInsumo">' +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '			    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Fornecedor</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Fornecedor\'"' +
            '                       ddc-mensagemvazio="\'NENHUM FORNECEDOR ENCONTRADO\'"' +
            '                       ddc-showcodigo="false"' +
            '                       ddc-showvalor="false"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="solicitacao.construcao"' +
            '                       ddc-item="cotacao"' +
            '                       ddc-lista="listaFornecedor"' +
            '                       set-selecionado="setSelecionadoFornecedor(selecionado,cotacao)"' +
            '                       get-lista="getListaFornecedor(texto,item,solicitacao)"' +
            '                       click-add="novoFornecedor()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Prazo (Dias)</label>' +
            '					<input type="text" class="form-control" placeholder="Dias" ng-model="cotacao.Prazo" ui-number-mask="0" required>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Frete ({{solicitacao.construcao.Moeda}})</label>' +
            '					<input type="text" class="form-control" placeholder="Frete" ng-model="cotacao.Frete" ui-number-mask="2" required>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Observação</label>' +
            '					<textarea type="text" class="form-control" placeholder="Observação" ng-model="cotacao.Texto" rows="4"></textarea>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group" ng-show="!cotacao.Selecionado">' +
            '           <div class="row">' +
            `               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">`+
            `                  <label>Tipo Pessoa:</label> <br />`+
            `                   <div class="btn-group" data-toggle="buttons">`+
            `                       <label class="btn btn-default" ng-class="{'active': cotacao.Fornecedor.TipoPessoa == 1}" ng-click="cotacao.Fornecedor.TipoPessoa = 1">`+
            `                           <input type="radio" name="tipoPE" id="optJuridica" value="1" autocomplete="off" ng-class="{'checkd': cotacao.Fornecedor.TipoPessoa == 1}"> Jurídica`+
            `                       </label>`+
            `                       <label class="btn btn-default" ng-class="{'active': cotacao.Fornecedor.TipoPessoa == 0}" ng-click="cotacao.Fornecedor.TipoPessoa = 0">`+
            `                           <input type="radio" name="tipoPE" id="optFisica" value="0" autocomplete="off" ng-class="{'checked': cotacao.Fornecedor.TipoPessoa == 0}"> Física`+
            `                       </label>`+
            `                   </div>`+
            `               </div>`+
            `               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">`+
            `                   <div ng-show="cotacao.Fornecedor.TipoPessoa == 0">`+
            `                       <div class="row">`+
            `                           <label>{{solicitacao.construcao.IdConfiguracao == 1 ? 'CPF:' : 'NIF:'}}</label>`+
            `                           <input type="text" class="form-control" placeholder="{{solicitacao.construcao.IdConfiguracao == 1 ? 'CPF:' : 'NIF:'}}" ng-model="cotacao.Fornecedor.Cnpj" name="txtCpf" ui-br-cpf-mask>`+
            `                       </div>`+
            `                   </div>`+
            `                   <div ng-show="cotacao.Fornecedor.TipoPessoa == 1">`+
            `                       <div class="row">`+
            `                           <label>{{solicitacao.construcao.IdConfiguracao == 1 ? 'CNPJ:' : 'NIF:'}}</label>`+
            `                           <input type="text" class="form-control" placeholder="{{solicitacao.construcao.IdConfiguracao == 1 ? 'CNPJ:' : 'NIF:'}}" ng-model="cotacao.Fornecedor.Cnpj" name="txtCnpj" ui-br-cnpj-mask>`+
            `                       </div>`+
            `                   </div>`+
            `               </div>` +
            `               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">`+
            `                   <label>Celular (WhatsApp)</label>`+
            `                   <input type="text" name="txtCelular" class="form-control" placeholder="Celular" ng-model="cotacao.Fornecedor.Celular" ui-br-phone-number required></input>`+
            `               </div>` +
            `               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">`+
            `                   <label>E-mail</label>`+
            `                   <input type="email" class="form-control" placeholder="E-mail" ng-model="cotacao.Fornecedor.Email" name="txtEmail">`+
            `               </div>` +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-click="salvarCotacaoFornecedor(solicitacao, cotacao); $event.stopPropagation();" ></itemsalvar>' +
            '           <itemcancelar ng-click="cancelarCotacaoFornecedor(solicitacao, cotacao); $event.stopPropagation();"></itemcancelar>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }

    $scope.getCotacaoItens = (solicitacao,cotacao) => {
        cotacao.openInsumos = !cotacao.openInsumos;
        cotacao.listaInsumoCotado = $filter('filter')(solicitacao.listaCotacaoALL, {IdFornecedor: cotacao.IdFornecedor});
        cotacao.listaInsumoCotado.forEach(i => {
            i.Editando = i.Valor == 0;
        });
    }

    $scope.alterarValorCotado = (cotado) => {
        cotado.Editando = !cotado.Editando
    }

    $scope.cancelarValorCotado = (cotado) => {
        cotado.Editando = !cotado.Editando
    }

    $scope.salvarValorCotado = (solicitacao, cotacao, cotado) => {
        var cotacaoItem = {
            IdCotacao: cotacao.IdCotacao,
            IdCotacaoItem: cotado.IdCotacaoItem,
            Valor: cotado.Valor
        }

        Cotacao.setValorCotacaoFornecedor(cotacaoItem,
            (data) => {
                cotacao.Valor = data.Instance.Valor;
                $scope.atualizaCotacaoALL(solicitacao);
            }
        );

        cotado.Editando = !cotado.Editando
    }

    $scope.salvarListaValorCotado = (solicitacao, cotacao) => {
        var lista = [];
        cotacao.listaInsumoCotado.forEach(cotado => {
            var cotacaoItem = {
                IdCotacao: cotacao.IdCotacao,
                IdCotacaoItem: cotado.IdCotacaoItem,
                Valor: cotado.Valor
            }
            lista.push(cotacaoItem);
            cotado.Editando = !cotado.Editando
        })

        Cotacao.setValorCotacaoFornecedores(lista,
            (data) => {
                $scope.atualizaCotacaoALL(solicitacao);
            }
        );
    }

    $scope.selecionaItemCotado = (solicitacao, cotado) => {
        var item = $filter('filter')(solicitacao.CotacaoFinal, {IdMaterial: cotado.IdMaterial})[0];

        if (cotado.Selecionado) {
            Cotacao.delSelecionadoCotacao({IdCotacaoItem: cotado.IdCotacaoItem},
                (data) => {
                    var idx = solicitacao.CotacaoFinal.indexOf(item);                    
                    solicitacao.CotacaoFinal.splice(idx, 1);

                    cotado.Selecionado = false;
                    solicitacao.ValorCotacaoFinal -= cotado.Valor*cotado.Quantidade;
                    $scope.atualizaValorFrete(solicitacao);
                }
            );
        }
        else {
            if (!solicitacao.CotacaoFinal)
                solicitacao.CotacaoFinal = [];

            if (!solicitacao.ValorCotacaoFinal)
                solicitacao.ValorCotacaoFinal = 0;

            // if (!item) {
                Cotacao.setSelecionadoCotacao({IdCotacaoItem: cotado.IdCotacaoItem},
                    (data) => {
                        cotado.Selecionado = true;
                        solicitacao.ValorCotacaoFinal += cotado.Valor*cotado.Quantidade;

                        solicitacao.CotacaoFinal.push(cotado);
                        $scope.atualizaValorFrete(solicitacao);
                    }
                );
            // }
            // else
            //     MsgBox.Atencao(cotado.Material, 'Já foi adicionado de outro fornecedor.',
            //         () => {}
            //     );
        }
    }

    $scope.getSelecionadosCotacao = (solicitacao) => {
        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao
        }

        solicitacao.CotacaoFinal = [];
        solicitacao.ValorCotacaoFinal = 0;
        solicitacao.ValorFreteFinal = 0;


        if (!solicitacao.construcao)
            solicitacao.construcao = $scope.getObraById(solicitacao.IdConstrucao);

        Cotacao.getSelecionadosCotacao(params,
            (data) => {
                solicitacao.Aprovacao = [];
                var dataHoje = new Date();
                var forn = undefined;
                data.Instance.forEach(
                    l => {
                        solicitacao.CotacaoFinal.push(l);
                        solicitacao.ValorCotacaoFinal += (l.Valor*l.Quantidade);
                        $scope.atualizaValorFrete(solicitacao);
                        var dataEntrega = new Date()
                        dataEntrega.setDate(dataEntrega.getDate() + l.Prazo);
                        
                        if (!forn || (forn.IdFornecedor != l.IdFornecedor) ) {
                            if (forn)
                                solicitacao.Aprovacao.push(forn);
                            forn = {
                                IdFornecedor: l.IdFornecedor,
                                IdCotacao: l.IdCotacao,
                                IdNotaFiscal: l.IdNotaFiscal,
                                DataEmissao: l.DataEmissaoCompra,
                                DataVencimento: l.DataVencimento ? l.DataVencimento : dataHoje,
                                DataEntrega: l.DataEntrega ? l.DataEntrega : dataEntrega,
                                RazaoSocial: l.RazaoSocial,
                                NomeFantasia: l.NomeFantasia,
                                Prazo: l.Prazo,
                                Frete: l.Frete,
                                Texto: l.Texto,
                                Valor: l.Valor*l.Quantidade,
                                Itens: [{
                                    IdSolicitacaoItem: l.IdSolicitacaoItem,
                                    Codigo: l.Codigo,
                                    Material: l.Material,
                                    Unidade: l.Unidade,
                                    Quantidade: l.Quantidade,
                                    Valor: l.Valor
                                }]
                            };
                        }
                        else {
                            forn.Itens.push({
                                IdSolicitacaoItem: l.IdSolicitacaoItem,
                                Codigo: l.Codigo,
                                Material: l.Material,
                                Unidade: l.Unidade,
                                Quantidade: l.Quantidade,
                                Valor: l.Valor
                            });
                            forn.Valor += l.Valor*l.Quantidade;
                        }
                    }
                );
                if (forn)
                    solicitacao.Aprovacao.push(forn);
            }
        );
    }

    $scope.atualizaValorFrete = (solicitacao) => {
        var IdFornecedor = 0;
        solicitacao.ValorFreteFinal = 0;
        solicitacao.CotacaoFinal.forEach(
            l => {
                if (l.Selecionado) {
                    if (IdFornecedor != l.IdFornecedor) {
                        IdFornecedor = l.IdFornecedor;
                        solicitacao.ValorFreteFinal += l.Frete;
                    }
                }
            }
        );        
    }

    $scope.getCotacaoALL = (solicitacao) => {
        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao
        }
        Cotacao.getCotacaoFornecedores(params,
            (data) => {
                solicitacao.listaCotacaoALL = data.Instance;
            }
        );
    }

    $scope.atualizaCotacaoALL = (solicitacao) => {
        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao
        }
        Cotacao.getCotacaoFornecedores(params,
            (data) => {
                solicitacao.listaCotacaoALL = data.Instance;
                for (var i in solicitacao.listaCotacao) {
                    solicitacao.listaCotacao[i].listaInsumoCotado = $filter('filter')(solicitacao.listaCotacaoALL, {IdFornecedor: solicitacao.listaCotacao[i].IdFornecedor});
                };
            }
        );
    }

    $scope.pdfOrdemCompra = (solicitacao, fornecedor) => {
        var cabecalho = {
            Avatar: solicitacao.construcao.ContaAvatar,
            Obra: solicitacao.construcao.Titulo,
            Conta: solicitacao.construcao.Conta,
            Moeda: solicitacao.construcao.Moeda,
            DescricaoObra: `Local: ${solicitacao.construcao.Endereco}, ${solicitacao.construcao.Numero}. ${solicitacao.construcao.Complemento} ${solicitacao.construcao.Bairro} ${solicitacao.construcao.Cidade} - ${solicitacao.construcao.Estado}
                            Telefone: ${solicitacao.construcao.Telefone}
                            Responsável: ${solicitacao.construcao.Contato}`
        };

        Solicitacao.pdfOrdemCompra(solicitacao.IdSolicitacao, fornecedor.IdFornecedor, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.setEmailCotacao = (solicitacao,cotacao) => {
        var params = {
            IdSolicitacao: cotacao.IdSolicitacao,
            IdFornecedor: cotacao.IdFornecedor,
            IdCotacao: cotacao.IdCotacao
        }

        Cotacao.setEmailCotacao(params, (data) => {
            $scope.atualizaCotacaoALL(solicitacao);
        });
    }

    $scope.reenvioEmailCotacao = (solicitacao,cotacao) => {
        var params = {
            IdCotacao: cotacao.IdCotacao
        }

        Cotacao.reenvioEmailCotacao(params, (data) => {
            $scope.getResumoCotacaoFornecedores(solicitacao);
        });
    }

    // $scope.getMapaCotacao = (solicitacao) => {
    //     var params = {
    //         IdSolicitacao: solicitacao.IdSolicitacao,
    //         IdConstrucao: solicitacao.IdConstrucao
    //     }

    //     Cotacao.getMapaCotacao(params,
    //         (data) => {
    //             console.log(data)
    //         });
    // }

    $scope.xlsMapaCotacao = (solicitacao) => {
        var obra = $scope.getObraById(solicitacao.IdConstrucao);
        var cabecalho = {
            Avatar: obra.ContaAvatar,
            Obra: obra.Titulo,
            Conta: obra.Conta,
            DataInicio: $filter("date")(obra.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")(obra.DataFim, 'dd/MM/yyyy'),
            Moeda: obra.Moeda,
            DescricaoObra: `Local: ${obra.Endereco}, ${obra.Numero}. ${obra.Complemento} ${obra.Bairro} ${obra.Cidade} - ${obra.Estado}
                            Telefone: ${obra.Telefone}
                            Responsável: ${obra.Contato}`
        };

        var params = {
            IdSolicitacao: solicitacao.IdSolicitacao,
            IdConstrucao: solicitacao.IdConstrucao,
            Cabecalho: JSON.stringify(cabecalho)
        }

        Cotacao.xlsMapaCotacao(params,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    /* FIM EDITAR COTAÇÃO */    

    $scope.getListaConstrucao = (callBack) => {
        var params = {
            permissao: ($scope.sessao.TipoPlano == 1 || $scope.sessao.ContaAdmin) ? undefined : 'GET_COMPRA_SOLICITACAO,GET_COMPRA_ALMOXARIFADO,GET_COMPRA_COTACAO,GET_COMPRA_APROVADA,GET_COMPRA_ENTREGUE,GET_COMPRA_ANALISE,GET_COMPRA_RETIRADA_ALMOXARIFADO', 
            refresh: $scope.refreshObra ? true: false,
            IdConstrucao: $scope.Notificacao ? $scope.Notificacao.IdConstrucao : undefined
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.refreshObra = undefined
                $scope.construcoes = obra
                callBack()
            }
        )
        // var params = { 
        //     Tipo: 0, 
        //     IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
        //     IdConstrucao: $scope.Notificacao ? $scope.Notificacao.IdConstrucao : undefined
        // }
        // var acessos = 'GET_COMPRA_SOLICITACAO,GET_COMPRA_ALMOXARIFADO,GET_COMPRA_COTACAO,GET_COMPRA_APROVADA,GET_COMPRA_ENTREGUE,GET_COMPRA_ANALISE,GET_COMPRA_RETIRADA_ALMOXARIFADO'
        // Construcao.getListaObras(params,
        //     (data) => {
        //         $scope.construcoes = []
        //         $scope.construcoes = data.Instance.filter(c => c.Acessos && c.Acessos.some(a => acessos.split(',').some(as => as == a)))
        //         callBack();
        //     }
        // );
    }

    $scope.filtraObraLista = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.listaSolicitacao = undefined;
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.listaSolicitacao = undefined;
        $scope.construcao = obra;
        CacheApp.setConstrucao($scope.construcao);
        $scope.HtmlManterObra = undefined

        $scope.listaRelatorio = [];
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0);
        $scope.loadPage(true);
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
        if (!$scope.openObra && $scope.construcao.Novo)
            $scope.loadObra()
    }

    $scope.adicionarObra = () => {
        if ($scope.sessao.TipoPlano == 3 && $scope.construcoes && $scope.construcoes.length > 2) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.construcao = { Tipo: 0, Dono: true, Novo: true }
        $scope.editarObra()
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra();
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.ObraSelecionada = $scope.construcoes.filter(c => c.Id == $scope.ObraSelecionada.Id)[0]
                $scope.listaSelecao = []
                $scope.listaSelecao.push({
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                })
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else {
                $scope.ObraSelecionada = undefined
                $scope.construcao = undefined
                $scope.listaSolicitacao = []
            }
        })
    }

    $scope.getObraById = (IdObra) => {
        var obra = {};
        $scope.construcoes.every(o => {
            obra = o;
            return !(o.Id == IdObra);
        });
        return obra;
    }

    $scope.getObraById = (Id) => {
        var obra = {};
        $scope.construcoes.every(o => {
            obra = o;
            return !(o.Id == Id);
        });
        return obra;
    }

    $scope.curvaAbcOrcamento = () => {
        if ($scope.listaSelecao.length > 1) {
            MsgBox.Atencao('Atenção!','Selecione apenas uma obra para acessar a Curva ABC de Insumos.',() => {
                setTimeout(() => {
                    document.getElementById('buttonOpenList').click()
                },100)
            });
            return;
        }

        $location.path('/curvaabcitemcompra');
    }

    $scope.validaAcessoRelatorio = () => {
        if ($scope.listaSelecao.length > 1) {
            MsgBox.Atencao('Atenção!','Selecione apenas uma obra para acessar o relatório.',() => {
                setTimeout(() => {
                    document.getElementById('buttonOpenList').click()
                },100)
            });
        }
    }

    $scope.loadPage = (loadObra) => {
        $scope.WorkFlowEnum = {
            SOLICITACAO: 'GET_COMPRA_SOLICITACAO',
            ALMOXARIFADO: 'GET_COMPRA_ALMOXARIFADO',
            COTACAO: 'GET_COMPRA_COTACAO',
            ANALISE: 'GET_COMPRA_ANALISE',
            APROVADA: 'GET_COMPRA_APROVADA',
            NAO_APROVADA: 'GET_COMPRA_NAO_APROVADA',
            COMPRA: 'GET_COMPRA_EFETUADA',
            ENTREGUE: 'GET_COMPRA_ENTREGUE',
            RETIRADA: 'GET_COMPRA_RETIRADA_ALMOXARIFADO',
            CANCELADO: 'GET_COMPRA_CANCELADO',
            CONCLUIDO: 'GET_COMPRA_CONCLUIDO',
            EXCLUIR: 'DEL_COMPRA_SOLICITACAO'
        }

        // $scope.listaSituacaoSelecionada = [
        //     'PEDIDO',
        //     'TRIAGEM',
        //     'COTAÇÃO',
        //     'APROVAÇÃO',
        //     'APROVADO',
        //     'NÃO APROVADO',
        //     'COMPRA',
        //     'ENTREGA',
        //     'RETIRADA'
        // ];

        $scope.listaSituacaoSelecionada = [
            {id: 1},
            {id: 2},
            {id: 3},
            {id: 4},
            {id: 5},
            {id: 6},
            {id: 7},
            {id: 8},
            {id: 9},
        ];

        $scope.listaSituacao = [
            {Id: 1, Nome: 'SOLICITAÇÃO', Chave: 'GET_COMPRA_SOLICITACAO'},
            {Id: 2, Nome: 'TRIAGEM', Chave: 'GET_COMPRA_ALMOXARIFADO'},
            {Id: 3, Nome: 'COTAÇÃO', Chave: 'GET_COMPRA_COTACAO'},
            {Id: 4, Nome: 'APROVAÇÃO', Chave: 'GET_COMPRA_ANALISE'},
            {Id: 5, Nome: 'APROVADO', Chave: 'GET_COMPRA_APROVADA'},
            {Id: 6, Nome: 'NÃO APROVADO', Chave: 'GET_COMPRA_NAO_APROVADA'},
            {Id: 7, Nome: 'COMPRA', Chave: 'GET_COMPRA_EFETUADA'},
            {Id: 8, Nome: 'ENTREGA', Chave: 'GET_COMPRA_ENTREGUE'},
            {Id: 9, Nome: 'RETIRADA', Chave: 'GET_COMPRA_RETIRADA_ALMOXARIFADO'},
            {Id: 10, Nome: 'CONCLUíDO', Chave: 'GET_COMPRA_CONCLUIDO'},
            {Id: 11, Nome: 'CANCELADA', Chave: 'GET_COMPRA_CANCELADO'},
        ];

        $scope.listaPrioridadeSelecionada = [];
        $scope.listaPrioridade = [
            {Nome: 'BAIXA', Id: 1},
            {Nome: 'MÉDIA', Id: 2},
            {Nome: 'ALTA', Id: 3},
        ];

        $scope.getTipoMaterial();
        $scope.getListaUnidades();
        $scope.getSolicitacaoSituacao();

        $scope.filterSituacao = [
            'GET_COMPRA_SOLICITACAO',
            'GET_COMPRA_ALMOXARIFADO',
            'GET_COMPRA_COTACAO',
            'GET_COMPRA_ANALISE',
            'GET_COMPRA_APROVADA',
            'GET_COMPRA_NAO_APROVADA',
            'GET_COMPRA_EFETUADA',
            'GET_COMPRA_ENTREGUE',
            'GET_COMPRA_RETIRADA_ALMOXARIFADO'
        ];

        if (loadObra) {
            $scope.construcao = CacheApp.getConstrucao();
            if (!$scope.construcao.Dono) {
                $scope.listaSituacao = $scope.listaSituacao.filter(s => $scope.construcao.Acessos.some(a => a == s.Chave))
                $scope.listaSituacaoSelecionada = $scope.listaSituacaoSelecionada.filter(ss => $scope.listaSituacao.some(s => s.Nome == ss))
                $scope.filterSituacao = $scope.filterSituacao.filter(f => $scope.listaSituacao.some(s => s.Chave == f))
            }

            $scope.filterObra = [$scope.construcao.Id];
            $scope.getFornecedoresAll($scope.construcao.IdClienteDono, ()=>{});
            $scope.inicializaPaginacao();
            $scope.getSolicitacoes();
        } else {
            if ($scope.listaSelecao.length == 1)
                CacheApp.setConstrucao($scope.getObraById($scope.listaSelecao[0].id));
            $scope.construcao = $scope.listaSelecao && $scope.listaSelecao.length > 0 ? $scope.getObraById($scope.listaSelecao[0].id) : undefined;
            $scope.filtraObra()
        }

    }

    $scope.sendZap = (cotacao) => {
        var msgSplit = cotacao.Url.split('#/?');
        var url = msgSplit[0] + '%23%2F%3F' + msgSplit[1].replace('+','%2B').replace('+','%2B').replace('+','%2B');
        var msg = encodeURI(`Olá ${cotacao.RazaoSocial}, gostaria de solicitar a cotação dos insumos da lista com prazo e taxa de entrega. \r\n\r\n Acesse o link: \r\n`) + url;
        window.open(`https://wa.me/55${cotacao.Telefone1}?text=${msg}`, '_blank');
    }

    $scope.goToNotaFiscal = (solicitacao, cotacao) => {
        var construcao = {};
        var construcao = $scope.getObraById(solicitacao.IdConstrucao);

        var params = { 
            Tipo: 1, 
            IdConstrucao: construcao.Id,
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined
        }
        Construcao.getListaObras(params,
            (data) => {
                CacheApp.setConstrucao(data.Instance[0]);
                $scope.AtualizaConstrucao();
                Compra.getNotasFiscais(construcao.Id, cotacao.IdNotaFiscal,
                    (data) => {
                        var notafiscal = data.Instance[0];
                        CacheApp.setNotaFiscal(notafiscal);
                        $location.path('/notafiscal/manter/debito');
                });
            }
        );
    };


    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim
        $scope.sessao = CacheApp.getSessao()
        
        $scope.reportList = [
            { Id: 0, Descricao: 'Lista Compras', Permissao: 'GET_COMPRA_SOLICITACAO', Url: 'relatoriocompras' },
            { Id: 1, Descricao: 'Lista Entrega', Permissao: 'GET_COMPRA_SOLICITACAO', Url: 'relatorioentregas' }
        ]

        if ($routeParams.from == 'geral') {
            if ($routeParams.idsolicitacao)
                $scope.Notificacao = {
                    IdConstrucao: $routeParams.idconstrucao,
                    IdSolicitacao: $routeParams.idsolicitacao
                }
            $scope.loadObra()
        }
        else
            $scope.loadPage(true);
        }
    );


  }]);
